import '@tensorflow/tfjs-backend-webgl';
import "@tensorflow/tfjs-backend-cpu"
import * as tfconv from '@tensorflow/tfjs-converter';
import * as deeplab from '@tensorflow-models/deeplab';
import { getLabels, getColormap, getURL, SemanticSegmentation, toSegmentationImage } from '@tensorflow-models/deeplab';

const base = 'cityscapes';        // set to your preferred model, out of `pascal`,
const createModel = async () => {
  // `cityscapes` and `ade20k`
  const quantizationBytes = 2;  // either 1, 2 or 4
  // use the getURL utility function to get the URL to the pre-trained weights
  const modelUrl = getURL(base, quantizationBytes);
  const rawModel = await tfconv.loadGraphModel(modelUrl);
  const modelName = 'pascal';  // set to your preferred model, out of `pascal`, `cityscapes` and `ade20k`
  return new SemanticSegmentation(rawModel, modelName);
};

const model = createModel();
model.then(() => console.log(`Loaded the model successfully!`));

self.addEventListener('message', async (e) => {

  const { pixels, width, height, i } = e.data;

  var array = new Uint8ClampedArray(pixels);

  var image = new ImageData(array, width, height);

  const result = await (await model).segment(image);

  //@ts-ignore
  self.postMessage({ i, result })

});