export default (img: Image) => {

  const canvas = document.createElement("canvas");
  canvas.width = img.width;
  canvas.height = img.height;

  const cx = canvas.getContext("2d");

  const imageData = new ImageData(
    new Uint8ClampedArray(img.overlayData),
    img.width,
    img.height
  );
  cx.putImageData(imageData, 0, 0);

  var link = document.createElement('a');
  link.download = img.name + '_mask.png';
  link.href = canvas.toDataURL()
  link.click();

}